//-----------------------------------------------------------------------------
//  CBT HOOK s DLL ʒmĂ炤NX
//-----------------------------------------------------------------------------

unit iRecentApps;

interface

uses
    Windows, Messages, Classes, SysUtils;

type
    TMessageOut = procedure(const Msg: string) of object;

    //  CBTtbNNX̃x[XNX(قƂǉȂ)
    TCbtHookReciever = class
    private
        FWndHandle: HWND;
        FEnabled: Boolean;
        FInstalled: Boolean;
        FMessageOut: TMessageOut;
        procedure WndProc(var Msg: TMessage); virtual;
    protected
        procedure DoTargetCreate(WH: HWND); virtual;
        procedure DoTargetDestroy(WH: HWND); virtual;
    public
        constructor Create();
        destructor Destroy; override;
        procedure Start();
        procedure Stop();
        property MessageOut: TMessageOut read FMessageOut write FMessageOut;
    end;

var
    CbtHookReciever: TCbtHookReciever = nil;    

implementation

const
    //  ʒmpEBhEbZ[W(DLL)
    UM_CREATEWND   = WM_APP + 1000; //  CBTProc(in DLL)
    UM_DESTROYWND  = WM_APP + 1001; //  CBTProc(in DLL)

    //  DLL
    HOOK_DLL_NAME  = 'hook.dll';

    //  DLLC|[gEăX^eBbNN
    function HookInstall(Wnd: HWND): Boolean; stdcall;external HOOK_DLL_NAME;
    procedure HookUnInstall(); stdcall;external HOOK_DLL_NAME;
    procedure HookInitialize(); stdcall;external HOOK_DLL_NAME;
    procedure HookFinalize(); stdcall;external HOOK_DLL_NAME;

//------------------------------------------------------------------------------
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html
function GetClassNameStr(hWindow:HWND):string;
var
  p:PChar;
  ret:integer;
begin
  GetMem(p,100);
  ret := GetClassName(hWindow,p,100);
  SetString(result,p,ret);
  FreeMem(p);
end;

//------------------------------------------------------------------------------
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html
function GetWindowTextStr(hWindow:HWND):string;
var
  p:PChar;
  ret:integer;
begin
  ret := GetWindowTextLength(hWindow);
  GetMem(p,ret+1);
  ret := GetWindowText(hWindow,p,ret+1);
  SetString(result,p,ret);
  FreeMem(p);
end;

//------------------------------------------------------------------------------
//  RXgN^
constructor TCbtHookReciever.Create();
begin
    inherited Create;
    // EBhERg[̂ӂ
    FWndHandle := Classes.AllocateHWnd(WndProc);
    // Ƃ肠
    FEnabled := False;
    //  tbN
    HookInitialize();
    //  tbNCXg[
    FInstalled := HookInstall(FWndHandle);
    //  bZ[W\Cxg
    FMessageOut := nil;
end;

//------------------------------------------------------------------------------
//  fXgN^
destructor TCbtHookReciever.Destroy;
begin
    FMessageOut := nil;
    //  tbNACXg[
    if (FInstalled) then HookUnInstall();
    //  tbNn
    HookFinalize();
    // EBhÊӂ蒆~
    Classes.DeallocateHWnd(FWndHandle);
    inherited;
end;

//------------------------------------------------------------------------------
//  EBhEꂽ
//  ۂɂ͔hNXŁAȂ̏\
procedure TCbtHookReciever.DoTargetCreate(WH: HWND);
var
    Msg: string;
begin
    Msg := Format('%s WINDOW CREATED   %10d [%s] - (%s)', [
        FormatDateTime('hh:nn:ss.zzz', Now()), WH,
        GetClassNameStr(WH),
        GetWindowTextStr(WH)
        ]);
    if Assigned(FMessageOut) then FMessageOut(Msg);
end;

//------------------------------------------------------------------------------
//  EBhEjꂽ
//  ۂɂ͔hNXŁAȂ̏\
procedure TCbtHookReciever.DoTargetDestroy(WH: HWND);
var
    Msg: string;
begin
    Msg := Format('%s WINDOW DESTROYED %10d', [FormatDateTime('hh:nn:ss.zzz', Now()), WH]);
    if Assigned(FMessageOut) then FMessageOut(Msg);
end;

//------------------------------------------------------------------------------
//  EBhEvV[W
//------------------------------------------------------------------------------
//  ms-help://MS.PSDK.1033/winui/winui/windowsuserinterface/windowing/hooks/
//  hookreference/hookfunctions/cbtproc.htm
//------------------------------------------------------------------------------
procedure TCbtHookReciever.WndProc(var Msg: TMessage);
begin
    //  tbNɐĂĒ~łȂꍇ
    if (FInstalled) and (FEnabled) then
    begin
        case Msg.Msg of
            //  EBhE쐬
            UM_CREATEWND: DoTargetCreate(Msg.WParam);
            //  EBhEj
            UM_DESTROYWND: DoTargetDestroy(Msg.WParam);
        end;
    end;
    // ̃bZ[W͒mBǂɂāB
    Msg.Result := DefWindowProc(FWndHandle, Msg.Msg, Msg.wParam, Msg.lParam);
end;

//------------------------------------------------------------------------------
//  󂯕t
procedure TCbtHookReciever.Start();
begin
    FEnabled := True;
end;

//------------------------------------------------------------------------------
//  󂯕t܂
procedure TCbtHookReciever.Stop();
begin
    FEnabled := False;
end;

end.

